'\" t
.\"     Title: guardcat_conf
.\"    Author: [see the "AUTHOR(S)" section]
.\" Generator: Asciidoctor 2.0.17
.\"      Date: 2023-01-01
.\"    Manual: \ \&
.\"    Source: \ \&
.\"  Language: English
.\"
.TH "GUARDCAT.CONF" "5" "2023-01-01" "\ \&" "\ \&"
.ie \n(.g .ds Aq \(aq
.el       .ds Aq '
.ss \n[.ss] 0
.nh
.ad l
.de URL
\fI\\$2\fP <\\$1>\\$3
..
.als MTO URL
.if \n[.g] \{\
.  mso www.tmac
.  am URL
.    ad l
.  .
.  am MTO
.    ad l
.  .
.  LINKSTYLE blue R < >
.\}
.SH "NAME"
guardcat.conf \- configuration file for guardcat(1)
.SH "SYNOPSIS"
.sp
\fB/etc/guardcat.conf\fP
.SH "DESCRIPTION"
.sp
The default config file is /etc/guardcat.conf and is loaded if no other
directives are given.
.sp
You can specify config directives on the command\-line to the program.  When
command\-line arguments are present, /etc/guardcat.conf is \fBnot\fP automatically
loaded.  Thus, to specify an alternate configuration file, one might use
something like this:
.sp
.if n .RS 4
.nf
.fam C
guardcat load /etc/guardcat/main.conf
.fam
.fi
.if n .RE
.sp
Example configuration files are provided with the guardcat package.  They can
be found in the "\fBcfexamples\fP" directory (which may vary by distribution).
.sp
Using guardcat to control your fans may damage your hardware.  There is \fBNO
WARRANTY\fP or assumption of liability.  Use it strictly \fBAT YOUR OWN RISK\fP.
.SH "SYNTAX"
.sp
The format is a series of keywords and/or values, separated by whitespace.
Keywords and values are cAsE\-sensitive.  Blank lines are ignored.  Anything
from a hash mark (pound sign) to end\-of\-line is ignored.
.sp
Multiple commands can be given on one line if separated by a semicolon (just
like the shell).  For the same reason, on the command\-line, you will need to
escape the semicolon to prevent the shell from interpreting it.
.sp
Both hash marks and semicolons must be separated from the rest of the
command (if any) by at least one white space character.  For example,
this would be an error:
.sp
.if n .RS 4
.nf
.fam C
pollint 60# poll once a minute
.fam
.fi
.if n .RE
.sp
You would need to do something like:
.sp
.if n .RS 4
.nf
.fam C
pollint 60 # poll once a minute
.fam
.fi
.if n .RE
.sp
Likewise, this will not work:
.sp
.if n .RS 4
.nf
.fam C
alert 36000;reset 36003
.fam
.fi
.if n .RE
.SH "GENERAL OPTIONS"
.sp
If a general option occurs more than once, later occurrences will override
previous ones.  Boolean options default to off, and are enabled by their
presence.  Repeated booleans are simply redundant.  There is no way to turn
something back off \(em you have to omit it in the first place.
.SS "debug"
.sp
Boolean.  Emit gobs of debugging info, to stderr and/or syslog LOG_DEBUG.  You
can also send SIGUSR2 to toggle debugging on and off once running.  When
debugging is enabled, the results of SIGUSR1 include a config dump.
.SS "quiet"
.sp
Boolean.  Suppress sending warning and debug messages to stderr (they still go
to syslog, as LOG_WARN or LOG_DEBUG, as appropriate).  Intended for use with
systemd, which captures stderr and sends it to the system log, resulting in
duplicates (as guardcat also logs to syslog).  Fatal errors always go to both \(em unless things are so broken that we cannot syslog (e.g., perl bombs out
loading the script), in which that systemd capture is really useful.
.SS "load"
.sp
Include another config file, as if it were typed here.  The following example
supposes inputs were broken out into a separate file.
.sp
.if n .RS 4
.nf
.fam C
load /etc/guardcat/inputs.conf
.fam
.fi
.if n .RE
.sp
The special value "\fB\-\fP" loads the default config file.  Especially useful on
the command line when adding one more parameter for testing.  For example, the
following command, given to the Unix shell, will load the normal config file,
but with debugging enabled (note the backslash that escapes the semicolon):
.sp
.if n .RS 4
.nf
.fam C
guardcat debug \(rs; load \-
.fam
.fi
.if n .RE
.sp
If you make a recursive loop of config file loads, guardcat will crash trying
to endlessly load the same file(s), so don\(cqt do that.  Typical diagnostics for
that case will be things like "deep recursion", "too many open files", and/or
"out of memory".
.SS "america"
.sp
Boolean.  Convert temperatures to Fahrenheit.  Any input declared as "\fBtemp\fP"
will be converted when it is read.  Parameter values specified in the config
file (min and max for inputs and alarms) will need to reflect that.  Logs and
alerts will use Fahrenheit when written.
.SS "pollint"
.sp
Poll interval, in seconds.  The default is 10.  This is how often we read
inputs/sensors and adjust outputs/fans.  Example:
.sp
.if n .RS 4
.nf
.fam C
pollint 10
.fam
.fi
.if n .RE
.SS "logint"
.sp
Data log interval, in multiples of the poll interval.  Default is 6.  Note
that data logging has nothing to do with syslog.  Examples:
.sp
.if n .RS 4
.nf
.fam C
pollint 10 ; logint  6 # log data once per minute
pollint 10 ; logint  3 # log data once every 30 seconds
pollint  5 ; logint 12 # log data once per minute.
logint 1               # log data with every poll cycle
.fam
.fi
.if n .RE
.sp
You can also send SIGUSR1 to poll and log immediately.  See also the
"\fBlogint\fP" option below, and the "\fBlog\fP" directive further below.
.SS "alert"
.sp
How often to alert when out\-of\-bounds, in seconds.  The default is 36000
seconds (10 hours).  Ten hours is somewhat arbitrary, but will at least walk
around the clock (so warnings do not occur at the same time every day, perhaps
being missed).
.sp
.if n .RS 4
.nf
.fam C
alert 36000
.fam
.fi
.if n .RE
.SS "reset"
.sp
How long before trouble is considered cleared, in seconds.  The warn interval
counter resets if things are good for this long.  The default is 3600 (1
hour), again somewhat arbitrary.
.sp
.if n .RS 4
.nf
.fam C
reset 3600
.fam
.fi
.if n .RE
.SS "logfile"
.sp
File to log data (sensor readings) to.  If no log file is specified, no data
logging will be done (default).  Send SIGHUP to re\-open the log file (useful
after log rotation).  See also the "\fBlog\fP" and "\fBlogint\fP" directives (below
and above, respectively).  Events and alerts are always logged to syslog.
.sp
.if n .RS 4
.nf
.fam C
logfile /var/log/sensors
.fam
.fi
.if n .RE
.sp
Log to /dev/stdout to have it log to your terminal (useful for testing).
.sp
.if n .RS 4
.nf
.fam C
logfile /dev/stdout
.fam
.fi
.if n .RE
.SS "mail"
.sp
Email alarm reports to this address.  Omit for no email reports (default).
Requires the \fImail\fP(1) utility to be available and working.
.sp
.if n .RS 4
.nf
.fam C
mail guardcat@example.com
.fam
.fi
.if n .RE
.SS "wall"
.sp
Boolean.  Use \fIwall\fP(1) to write alert messages to all users and terminals.
Default is disabled.
.SH "SPECIFYING PATHS"
.sp
guardcat is intended to mainly work with the Linux kernel "hwmon" interface
(which usually appears in the filesystem under \fB/sys/class/hwmon/\fP).  Every
input (temperature or fan speed sensor) and output (fan speed control) will
correspond to a hwmon file path.  These paths must be specified in the
configuration you provide.
.sp
guardcat provides multiple ways to specify a hwmon path.
.SS "hwmlabel"
.sp
You can specify the hwmon device name and channel label.  This is
the best approach when labels are available, as it is clearer to read, more
obvious what the config directive does, and will withstand changes in device
ordering (as can happen when the kernel changes).  However, labels are not
always provided.  The combination of device and channel name/label must also
be unique.
.sp
.if n .RS 4
.nf
.fam C
input CPUin \- \- hwmlabel nct6798 CPUTIN
.fam
.fi
.if n .RE
.SS "hwmfile"
.sp
You can specify the hwmon device name, and a file name under that device.
This is the usually the best choice for fan\-related sensors.  This is also the
only type (besides "\fBpath\fP") available for \fBoutput\fP, \fBinit\fP, and \fBexit\fP
declarations.
.sp
.if n .RS 4
.nf
.fam C
input CPUin \- \- hwmfile nct6798 temp2_input
.fam
.fi
.if n .RE
.SS "path"
.sp
You can specify the path directly.  This works even when names are ambiguous
(duplicated), or if guardcat cannot find labels/names/etc.  It can also work
for things which are not hwmon nodes \(em even regular files, although that may
be of limited usefulness.
.sp
.if n .RS 4
.nf
.fam C
input CPUin \- \- path /sys/class/hwmon/hwmon0/temp2_input
.fam
.fi
.if n .RE
.SS "wwid"
.sp
If the "\fBdrivetemp\fP" kernel module is loaded (and your disk drives are
compatible), you can specify the WWID (world\-wide identifier, also called a
WWN, world\-wide name) of the drive, and guardcat will find it.  You must
specify the WWID as hwmon presents it, which might not match the printed label
of the drive.
.sp
.if n .RS 4
.nf
.fam C
input SSD \- \- temp wwid naa.5002536e42630f9d
.fam
.fi
.if n .RE
.SS "Discovering paths"
.sp
A quick way to see the available hwmon devices is to run the shell command:
.sp
.if n .RS 4
.nf
.fam C
grep . /sys/class/hwmon/hwmon*/name
.fam
.fi
.if n .RE
.sp
Likewise, to see the labeled inputs:
.sp
.if n .RS 4
.nf
.fam C
grep . /sys/class/hwmon/hwmon*/*_label
.fam
.fi
.if n .RE
.sp
To see the drives and WWIDs that hwmon sees:
.sp
.if n .RS 4
.nf
.fam C
grep . /sys/class/hwmon/hwmon*/device/{model,wwid}
.fam
.fi
.if n .RE
.sp
(In all these examples, I am (ab)using \fIgrep\fP(1) simply to put the path names
in front of the file contents.)
.SH "STARTUP VALUES"
.sp
It may be useful to have guardcat write fixed values to hwmon nodes during
program startup.  They can be specified with "\fBhwmfile\fP" or "\fBpath\fP".
.sp
For example, some mainboards require the fan control mode be set to "manual
control" before they will honor the PWM output setting.  This is done by
writing "1" to the appropriate hwmon pwm*_enable node.  Examples:
.sp
.if n .RS 4
.nf
.fam C
init 1 path    /sys/class/hwmon/hwmon0/pwm1_enable
init 1 hwmfile nct6798 pwm2_enable
.fam
.fi
.if n .RE
.sp
Values are written in the order defined.  An error writing an "\fBinit\fP" value
will abort the program.
.SH "SHUTDOWN VALUES"
.sp
If guardcat is being used for fan control, you will almost certainly want it
to do some kind of "restore" action upon exit. Otherwise, fans may stay at a
slow speed as things heat up, and with guardcat not controlling them any
longer, the system may overheat.  Examples:
.sp
.if n .RS 4
.nf
.fam C
# On exit, set fan #1 to maximum speed
exit 255 hwmfile nct6798 pwm1
.fam
.fi
.if n .RE
.sp
.if n .RS 4
.nf
.fam C
# On exit, set fan #1 to "Smart Fan" mode
exit 5   hwmfile nct6798 pwm1_enable
.fam
.fi
.if n .RE
.sp
.if n .RS 4
.nf
.fam C
# On exit, set fan #1 to "control disabled" (max speed)
exit 0   hwmfile nct6798 pwm1_enable
.fam
.fi
.if n .RE
.sp
Values are written in the order defined.  Errors result in warnings, but the
program will continue trying the rest.  guardcat normally tries to write these
values even if it is aborting/crashing.  The exception is if no \fBinit\fP or
\fBoutput\fP values have been written yet \(em the theory being, if no changes have
been made, nothing needs to be put back.
.SH "INPUT CHANNELS"
.sp
Input channels are intended for sensors, such as temperature or fan speed.
These are sometimes called "direct inputs", to differentiate them from
aggregate inputs (see below).  An input declaration consists of the following:
.sp
.if n .RS 4
.nf
.fam C
input <name> <lo> <hi> [options] <type> <arguments>
.fam
.fi
.if n .RE
.sp
The \fIname\fP is arbitrary, but must be unique.  It may not contain spaces.
.sp
The \fIlo\fP and \fIhi\fP fields define the range of the sensor values expected during
normal operation.  They are used to compute a normalized value for each input,
which in turn is used to adjust outputs proportionally.  If an input is not
being used to control an output (i.e., it is used only for
monitoring/logging), the \fIlo\fP and/or \fIhi\fP fields may be given as "\fB\-\fP".
.sp
Zero or more options may be specified.  Options and any arguments are all
separated by spaces.  Options end when a recognized input type is seen.  See
\fBINPUT OPTIONS\fP below for available options.
.sp
The type specifies the mechanism used to obtain the input value.  Most types
specify a (virtual) file to read from, typically a hwmon node. See the section
\fBSPECIFYING PATHS\fP for details.  All the types given in that section work for
inputs.
.sp
The other available input type is "\fBprog\fP", which specifies a program to run.
The program is expected to write the value to stdout (followed by a newline),
and then exit.  See \fBSECURITY\fP in \fIguardcat\fP(1) for implications.  Since the
program must be (re)started with each read, there is a performance cost;
perhaps significant.  See the related "\fBslow\fP" option below.  guardcat will
wait for the program to produce output. If the program hangs, so will
guardcat.  That could be bad if guardcat is providing fan control.
.sp
Some examples:
.sp
.if n .RS 4
.nf
.fam C
#     name lo hi options    type     arguments
       input CPU  30 65 temp       hwmlabel k10temp Tdie
       input HDD  20 35 temp       wwid     naa.5002538d42660d9e
       input FAN  \-  \-                     hwmfile  nct6798 fan1_input
input ROOM \-  \-  slow round prog     /usr/local//bin/tempered \-n
.fam
.fi
.if n .RE
.SH "AGGREGATE INPUTS"
.sp
Inputs can be combined into an aggregate input channel.  An aggregate input is
the same as a direct input for purposes of monitoring, logging, and control,
but is based on the values of other inputs, rather than an external file or
program.
.sp
An aggregate declaration consists of the following:
.sp
.if n .RS 4
.nf
.fam C
agg <name> [options] <type> <constituents> ...
.fam
.fi
.if n .RE
.sp
The names for aggregate inputs follow the name rules, and use the same
namespace, as direct inputs.
.sp
The only option currently supported for "\fBagg\fP" is the "\fBround\fP" option.  See
\fBINPUT OPTIONS\fP for usage.
.sp
Three types of aggregate inputs are currently supported, with the keywords
"\fBmin\fP", "\fBmax\fP", and "\fBavg\fP".  They correspond to minimum, maximum, and
average (arithmetic mean), respectively.  The value of the aggregate channel
will become the lowest, highest, or average value of the specified constituent
inputs.
.sp
Following the type is a list of one or more constituent inputs.  Any such
inputs must have been previously defined (e.g., come earlier in the config
file).  The constituent inputs to an aggregate can include other aggregate
inputs.
.sp
Examples:
.sp
.if n .RS 4
.nf
.fam C
agg MIN round min CPU1 CPU2 SSDa
agg MAX round max CPU2 CPU1 SSDa
agg AVG round avg CPU1 CPU2 SSDa
.fam
.fi
.if n .RE
.SH "INPUT OPTIONS"
.sp
Options may be specified for "\fBinput\fP" or "\fBagg\fP" (aggregate input) channels.
.SS "slow"
.sp
Flags the input as a slow input.  Slow inputs are only read when the poll
cycle is one which will write to the data log (see "\fBlogint\fP" in \fBGENERAL
OPTIONS\fP).  The envisioned use case is: Have guardcat provide fan control
based on hwmon inputs on a fast poll cycle, while also logging an external
program on a less\-frequent basis.
.SS "mult"
.sp
Specifies a multiplier, a value applied to the input value before further
processing.  Intended for scaling.  The "\fBmult\fP" keyword is followed by the
number to multiply by (which need not be an integer).
.SS "offset"
.sp
Specifies an offset, a value added to the input value, after the above, but
before any further processing.  The "\fBoffset\fP" keyword is followed by the
number to add (which need not be an integer, nor positive).
.SS "round"
.sp
Rounds the input value to the nearest tenth (one decimal place past zero),
after the above, but before display or further processing.
.SS "temp"
.sp
Flags the input channel as a temperature value.  Implicitly applies the
options "\fBmult 0.001\fP" and "\fBround\fP", both of which will generally be
appropriate for hwmon temperature values.  Additionally, if the "\fBamerica\fP"
general option is in effect, the input is assumed to be in Celsius, and will
be converted to Fahrenheit.
.SH "DATA LOG CHANNELS"
.sp
Once input and/or aggregate channels are defined, you can specify which ones
(if any) you want logged to the data log.  See also "\fBlogint\fP" and "\fBlogfile\fP"
in \fBGENERAL OPTIONS\fP.  By default, no data logging is done.  Example:
.sp
.if n .RS 4
.nf
.fam C
log CPU1 CPU2 SSD AVG
.fam
.fi
.if n .RE
.SH "ALARM LIMITS"
.sp
An alarm declaration consists of the following:
.sp
.if n .RS 4
.nf
.fam C
alarm <name> <lo> <hi>
.fam
.fi
.if n .RE
.sp
The name must match an already\-defined input/aggregate channel name.  The \fIlo\fP
and \fIhi\fP values must be present, but either may be "\fB\-\fP". If the actual value
for the corresponding channel goes below \fIlo\fP, or above \fIhi\fP, it is considered
out\-of\-bounds (faulted).  If a field is given as "\fB\-\fP" then that end of the
range is not checked.
.sp
If one or more sensors becomes faulted, an alert is raised.  The alert will be
repeated on the interval given by the "\fBalert\fP" option.  If all sensors return
back in\-bounds for the "\fBreset\fP" interval, the alarm is considered cleared.
.sp
Raising an alert consists of one or more of:
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.  sp -1
.  IP \(bu 2.3
.\}
Logging to syslog at priority LOG_ALERT
.RE
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.  sp -1
.  IP \(bu 2.3
.\}
Sending an email to the address specified by the "\fBmail\fP" option
.RE
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.  sp -1
.  IP \(bu 2.3
.\}
Sending a message to all logged\-in users, per the "\fBwall\fP" option
.RE
.sp
Examples:
.sp
.if n .RS 4
.nf
.fam C
#     name lo  hi
       alarm ROOM 10  30       # Alert if it gets too warm, or really cold
       alarm CPU  \-   150      # Just alert on over\-temperature for CPUs
       alarm FANS 200 \-        # Alert on low speed for fans
.fam
.fi
.if n .RE
.SH "OUTPUT CHANNELS"
.sp
Output channels are provided for fan control.  An output declaration consists
of the following:
.sp
.if n .RS 4
.nf
.fam C
output <input> <lo> <hi> [options] <type> <arguments>
.fam
.fi
.if n .RE
.sp
The first field is the name of an already\-defined input or aggregate channel,
which will control the output.  Unlike "\fBinput\fP", "\fBagg\fP", and "\fBalarm\fP"
declarations, an output with the same input channel name may be repeated.
This allows multiple outputs to be controlled by the same input.
.sp
The \fIlo\fP and \fIhi\fP fields define the range over which the output varies, in
proportion to the input range.  Typically, a hwmon fan control channel uses a
range from 0 (zero, stopped) to 255. However, the actual fans will typically
cease turning well above the 0 point, so some experimentation will be required
to determine the proper values for your hardware.
.sp
The only option currently supported for "\fBoutput\fP" is the "\fBfloor\fP" option.
It specifies a minimum value for the output, independent of the lo/hi range.
Again, this may be useful for fans, which have some minimum threshold.
.sp
Two types are supported for outputs: "\fBhwmfile\fP" and "\fBpath\fP".  See the
section \fBSPECIFYING PATHS\fP for usage of these.
.sp
Examples:
.sp
.if n .RS 4
.nf
.fam C
#      in    lo  hi  option   type    data
output CPU   30  255          hwmfile nct6798 pwm1
output ALL   30  255          hwmfile nct6798 pwm2 # top
output ALL   30  255 floor 55 hwmfile nct6798 pwm3 # bottom
.fam
.fi
.if n .RE
.SH "SEE ALSO"
.sp
\fIguardcat\fP(1), \fIsensors\fP(1), \fIpwmconfig\fP(1)
.sp
In particular, see the \fBWARNINGS\fP and \fBSECURITY\fP sections of \fIguardcat\fP(1) for
important safety tips.
.SH "LICENSE"
.sp
This manual page and accompnaing software is licensed under the terms of the
Unlicense.  For the full terms, see the accompaning \fBUNLICENSE\fP file, or the
.URL "http://unlicense.org/" "" ""
website.  To summarize, you can do anything you want
with it, and there is \fBNO WARRANTY\fP, nor any assumptuion of liability.  Any
and all use is strictly \fBAT YOUR OWN RISK\fP.