'\" t
.\"     Title: guardcat
.\"    Author: [see the "AUTHOR(S)" section]
.\" Generator: Asciidoctor 2.0.17
.\"      Date: 2023-01-02
.\"    Manual: \ \&
.\"    Source: \ \&
.\"  Language: English
.\"
.TH "GUARDCAT" "8" "2023-01-02" "\ \&" "\ \&"
.ie \n(.g .ds Aq \(aq
.el       .ds Aq '
.ss \n[.ss] 0
.nh
.ad l
.de URL
\fI\\$2\fP <\\$1>\\$3
..
.als MTO URL
.if \n[.g] \{\
.  mso www.tmac
.  am URL
.    ad l
.  .
.  am MTO
.    ad l
.  .
.  LINKSTYLE blue R < >
.\}
.SH "NAME"
guardcat \- Monitor, log, alert, and control for PC hardware sensors and fans
.SH "SYNOPSIS"
.sp
\fBguardcat\fP [\fIconfig\-directives\fP]
.SH "DESCRIPTION"
.sp
guardcat is a watchdog program intended to monitor sensor readings provided by
the "\fBhwmon\fP" interface of the Linux kernel.  It can also read values from
external programs.  It can raise alerts if the readings go outside of limits
you define.  Alerts can be indicated using \fIsyslog\fP(3), \fImail\fP(1), and/or
\fIwall\fP(1).  It can log sensor readings to a data log file periodically.  It
can control fan speed in response to temperature inputs.  All these features
are optional and configurable.
.sp
Using guardcat to control your fans may damage your hardware.  There is \fBNO
WARRANTY\fP or assumption of liability.  Use it strictly \fBAT YOUR OWN RISK\fP.
See the section on \fBWARNINGS\fP below for more.  There may also be security
implications; see the \fBSECURITY\fP section.
.SH "INVOCATION"
.sp
guardcat is a Perl script intended to be run as a daemon.  It does not
automatically fork; you will need to background it yourself, or use a daemon
control facility such as \fIinittab\fP(5) or \fIsystemd\fP(8).  A suitable systemd
service unit is provided with the guardcat package.  It can also be run
in the foreground, which is useful mainly for debugging.
.sp
Command\-line arguments to guardcat are configuration directives, as described
in \fIguardcat.conf\fP(5).  If no such areguments are given, the default
configuration file is read, instead.  If neither are present, guardcat aborts.
.SH "CONFIGURATION"
.sp
guardcat requires a user\-specified configuration to run.  Configuration
directives can be supplied on the command\-line, or using a configuration file
(\fB/etc/guardcat.conf\fP by default), or both.  Using a file is the recommended
method.
.sp
The configuration must define the inputs you want to monitor.  It can
optionally define alarms, outputs, logging, and other parameters, as well.
Thee \fIguardcat.conf\fP(5) for the available configuration directives and their
usage.
.sp
To alter the configurarion of a running guardcat instance, you must restart
the guardcat program.
.SH "THEORY OF OPERATION"
.SS "Polling Loop"
.sp
Guardcat runs a polling loop that consists of:
.sp
.RS 4
.ie n \{\
\h'-04' 1.\h'+01'\c
.\}
.el \{\
.  sp -1
.  IP " 1." 4.2
.\}
Read inputs (sensors)
.RE
.sp
.RS 4
.ie n \{\
\h'-04' 2.\h'+01'\c
.\}
.el \{\
.  sp -1
.  IP " 2." 4.2
.\}
Transform input values
.sp
.RS 4
.ie n \{\
\h'-04' 1.\h'+01'\c
.\}
.el \{\
.  sp -1
.  IP " 1." 4.2
.\}
Scaling (\fBmult\fP option)
.RE
.sp
.RS 4
.ie n \{\
\h'-04' 2.\h'+01'\c
.\}
.el \{\
.  sp -1
.  IP " 2." 4.2
.\}
Shifting (\fBoffset\fP option)
.RE
.sp
.RS 4
.ie n \{\
\h'-04' 3.\h'+01'\c
.\}
.el \{\
.  sp -1
.  IP " 3." 4.2
.\}
Celsius to Fahrenheit conversion (\fBtemp\fP and \fBamerica\fP options)
.RE
.sp
.RS 4
.ie n \{\
\h'-04' 4.\h'+01'\c
.\}
.el \{\
.  sp -1
.  IP " 4." 4.2
.\}
Rounding
.RE
.sp
.RS 4
.ie n \{\
\h'-04' 5.\h'+01'\c
.\}
.el \{\
.  sp -1
.  IP " 5." 4.2
.\}
Normalization
.RE
.sp
.RS 4
.ie n \{\
\h'-04' 6.\h'+01'\c
.\}
.el \{\
.  sp -1
.  IP " 6." 4.2
.\}
Aggregation
.RE
.RE
.sp
.RS 4
.ie n \{\
\h'-04' 3.\h'+01'\c
.\}
.el \{\
.  sp -1
.  IP " 3." 4.2
.\}
Write outputs (fan speeds), if configured
.RE
.sp
.RS 4
.ie n \{\
\h'-04' 4.\h'+01'\c
.\}
.el \{\
.  sp -1
.  IP " 4." 4.2
.\}
Check alarm limits and raise alerts
.RE
.sp
.RS 4
.ie n \{\
\h'-04' 5.\h'+01'\c
.\}
.el \{\
.  sp -1
.  IP " 5." 4.2
.\}
Write sensor values to data log, if appropriate (per \fBlogint\fP)
.RE
.sp
.RS 4
.ie n \{\
\h'-04' 6.\h'+01'\c
.\}
.el \{\
.  sp -1
.  IP " 6." 4.2
.\}
Sleep for the poll interval (\fBpollint\fP)
.RE
.sp
.RS 4
.ie n \{\
\h'-04' 7.\h'+01'\c
.\}
.el \{\
.  sp -1
.  IP " 7." 4.2
.\}
Repeat
.RE
.SS "Fan Control"
.sp
When configured for fan control, guardcat sets the output in direct proportion
to the controlling sensor input.  For example, if you have defined a sensor
with a range from 20 to 40, and the sensor is read at 30, then guardcat will
set any corresponding output to 50%.  If the output range was configured as
from 30 to 255, 50% would result in 113 being written.
.sp
By adjusting the input (temperature) range, one can fine\-tune how aggressive
the fan response is to that input.  Lowering the \fIhi\fP value will result in the
fan speed increasing sooner.  Raising the \fIhi\fP value will cause the fan speed
to increase more slowly.
.sp
For aggregate channels, the normalized values of the inputs are the ones
considered when used to control an output.  So, for a \fBmax\fP aggregate, given
two inputs, one reading 39 with range 20 to 40 (95%), and the other reading 45
with range 20 to 80 (42%), any output would be set to 95% (despite 45 being
larger than 39).
.sp
In the future, more sophisticated control algorithms and mechanisms may be
offered.  (Patches welcome!)
.SS "Invalid Readings"
.sp
If any sensor value cannot be read, or cannot be interpreted as a number, that
input channel will be considered invalid for that poll cycle.  This could
happen if a path is specified incorrectly, a device is removed while running,
permission is denied, an external program fails, or any number of other
problems.
.sp
guardcat will continue to try and read the channel with each poll cycle, as
problems may be temporary and be resolved during the program run.
.sp
If data logging is configured for an invalid channel, it will be logged as \-1
(negative one).  This has the advantage of being obviously bad, while still
being plottable or otherwise processed by external utilities.
.sp
If an output depends on an invalid channel, the output will be set to its
maximum value (i.e., fan at highest speed).
.sp
If an invalid channel is being used as part of an aggregate input, it will be
ignored for purposes of computing the absolute reading (i.e., the value
displayed or logged), but the maximal normalized reading (100%) from the
invalid channel will be propagated to any outputs.  Thus, the data log for an
aggregate will reflect available data, ignoring bad channels, while fans will
still be forced to maximum.
.SH "SIGNALS"
.sp
Like most daemon\-type programs, guardcat will trap termination signals
(\fBSIGTERM\fP, \fBSIGINT\fP, etc.), perform a graceful shutdown, and then exit.  In
particular, it will process \fBexit\fP config directives, which (if one is using
guardcat for fan control) should reset fans to maximum.  It will also try to
do the same on abort signals (\fBSIGSEGV\fP, etc.).
.sp
Aside from the above, guardcat recognizes the following operational signals:
.SS "SIGHUP"
.sp
Upon receipt of \fBSIGHUP\fP, guardcat will close any data log file, and then
re\-open it with the same name.  The header will be written again.  Logging
will then resume as before.  If no data log is configured, the signal does
nothing.
.sp
This is intended for log rotation scenarios.  The active log can be safely
moved to a new name/directory, and then \fBSIGHUP\fP sent to create a new log file
at the original name and location.
.SS "SIGUSR1"
.sp
Upon receipt of \fBSIGUSR1\fP, guardcat will immediately perform a full poll cycle
(including any slow inputs), and log the resulting values to any data log.
When debugging is enabled, guardcat will also dump its internal state.
.sp
Intended for use when someone is following the data log (perhaps with
\fItail\fP(1) and the \fB\-f\fP switch), and wants to see current values immediately.
.SS "SIGUSR2"
.sp
Toggles debugging on and off.  Debugging dumps gobs of information to stderr
and/or syslog LOG_DEBUG, and is generally only useful if you are familiar with
the program internals.  See also the "\fBdebug\fP" directive in
\fIguardcat.conf(5)\fP.
.SH "WARNINGS"
.sp
Using guardcat to control your fans may damage your hardware.  There is \fBNO
WARRANTY\fP or assumption of liability.  Use it strictly \fBAT YOUR OWN RISK\fP.
.sp
If you are using guardcat for fan control, the proper cooling of your hardware
will depend on how you configure guardcat.  Improper cooling can result in
high component temperatures, stressing the components, and possibly causing
premature failure (immediately, or over time).
.sp
If guardcat crashes, and appropriate \fBexit\fP directives were not configured, or
guardcat fails to process them, the system may be left without fan control.
If system load or heat then increases, it may result in overheating.
.sp
If an input file (sensor) blocks while guardcat is trying to read it, guardcat
will hang, waiting for the data.  This isn\(cqt supposed to happen, but a kernel
bug or malfunctioning sensor chip may cause unexpected problems.  In such a
hung state, guardcat will not adjust any fans, nor raise any alerts.  This
could be worse than a crash, since a crash might at least process \fBexit\fP
directives.  The same scenario applies to an external program (\fBprog\fP inputs)
which does not produce output in a timely matter.
.sp
See also the warnings in the \fBSECURITY\fP section.
.SH "SECURITY"
.sp
In order to adjust fan speeds, guardcat will need to be run as root.
.sp
If guardcat is running as root, it of course has the highest privilege.  Any
privileged process warrants a higher level of security concern.
.SS "Exposures"
.sp
By design, the guardcat config file can be used to tell guardcat to write an
arbitrary value to an arbitrary file, or run an arbitrary program with
arbitrary arguments.  If running privileged, it is a very short step from
this, to taking total control of the system, or simply rendering it unusable.
(For example, overwriting the /etc/passwd or /vmlinuz files, or something less
obvious.)
.sp
Specifics: The "\fBlogfile\fP", "\fBinit\fP", "\fBexit\fP", and "\fBoutputs\fP" directives all
specify files to write to.  The "\fBinit\fP" and "\fBexit\fP" directives additionally
specify an arbitrary value to be written.  The "\fBprog\fP" input type runs an
external program.
.SS "Config File Permissions"
.sp
The config file should thus be protected from modification by anyone other
than fully trusted users.  Appropriate ownership and permissions are most
likely root/root with mode 600.  Typical commands to do so would be:
.sp
.if n .RS 4
.nf
.fam C
chown root:root /etc/guardcat.conf
chmod u=rw,og=  /etc/guardcat.conf
.fam
.fi
.if n .RE
.SS "External Programs"
.sp
If you do run an external program from guardcat, it will run with the same
privileges as guardcat, i.e., root in this scenario.  Make sure the external
program is fully suited to this privilege level as well.
.SS "Output Files"
.sp
If an attacker can write to the directory containing any output file (log
file, control nodes, etc.), they can redirect the output with a symlink, again
potentially leading to system corruption, or worse.
.SS "Restricted Operation"
.sp
If you are only using guardcat for monitoring, alerting, and/or logging, it
should be able to run with limited privileges, as normally any user can read
hwmon values.  The usual method would be to create a dedicated user for
guardcat, and configure the systemd unit (or rc script, or whatever) to run
guardcat as that user.  If logging data, the log file should be set with
permissions that allow that user to write to the file.
.SH "SEE ALSO"
.sp
\fIguardcat.conf\fP(5), \fIsensors\fP(1), \fIpwmconfig\fP(1)
.SH "DEDICATION"
.sp
guardcat is dedicated to the author\(cqs dear departed cat Franklin, who was the
original Guard Cat.
.SH "LICENSE"
.sp
This manual page and accompnaing software is licensed under the terms of the
Unlicense.  For the full terms, see the accompaning \fBUNLICENSE\fP file, or the
.URL "http://unlicense.org/" "" ""
website.  To summarize, you can do anything you want
with it, and there is \fBNO WARRANTY\fP, nor any assumptuion of liability.  Any
and all use is strictly \fBAT YOUR OWN RISK\fP.